明经CAD社区

 找回密码
 注册

扫一扫,访问微社区

QQ登录

只需一步,快速开始

查看: 622|回复: 4

请问如何遍历多个图纸空间(paperspace)?

[复制链接]
发表于 2015-3-29 17:03 | 显示全部楼层 |阅读模式
本帖最后由 20060510412 于 2015-3-29 17:14 编辑

我想使用vba遍历dwg文件里面的所有对象,遇到了一个问题:
如果是遍历模型空间里面的对象比较简单,如下:
For Each ent In objDBX.ModelSpace
如果是遍历图纸空间里面的对象,起初我是用的这一句:
For Each ent In objDBX.PaperSpace
后来发现这样是有问题的:因为我的图纸里面有多个图纸空间,而上面这句代码遍历的只是当前被激活的图纸空间,请问应该如何遍历所有的图纸空间呢?

发表于 2018-1-4 12:42 | 显示全部楼层
    For Each MyLayout In ThisDrawing.Layouts
        If MyLayout.ModelType = False Then
           ThisDrawing.ActiveLayout = MyLayout
           'do event
        End If
    Next
回复 支持 1 反对 0

使用道具 举报

发表于 2015-3-29 20:06 | 显示全部楼层
  1. Public Sub ss()
  2. Dim objB As AcadBlock, obj1 As AcadObject
  3. For Each objB In ThisDrawing.Blocks
  4.     Debug.Print objB.Name
  5.     For Each obj1 In objB
  6.         Debug.Print Space(6); obj1.ObjectName
  7.     Next obj1
  8. Next objB
  9. End Sub
 楼主| 发表于 2015-3-29 20:52 | 显示全部楼层
zzyong00 发表于 2015-3-29 20:06

太感谢了!这个问题困扰了我好久,一直不知道怎么解决。
发表于 2018-1-3 18:42 | 显示全部楼层

如果要遍历每个空间的同时,激活这些空间为active,怎么操作?
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号  
©2000-2017 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2018-9-26 21:38 , Processed in 0.245573 second(s), 28 queries , Gzip On.

Powered by Discuz! X3.3

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表